//---------------------------------------------------------------------------

#ifndef nkfdllH
#define nkfdllH
//---------------------------------------------------------------------------

typedef int (*FNConvertStreamCallback)(int ch, class TNkf *obj);

class TNkf {
protected:
	class TNkfLoader *Dll;
public:
	TNkf(const tchar *dllpath);
	virtual ~TNkf();
	bool IsValid() const;
	void SetOption(const char *option);
	bool ConvertFile(const tchar *filename, const tchar *out);
	bool ConvertStream(const tchar *filename, FNConvertStreamCallback os);
	__tnstrA GetGuess();
protected:
	FILE *fp;
	FNConvertStreamCallback OutStream;
	static int CALLBACK cbInFileStream(int userdata, int ch);
	static int CALLBACK cbOutStream(int userdata, int ch);
public:
	int Guess(const tchar *str);
};

#endif

